package com.zskk.controller;

import com.jfinal.weixin.sdk.api.ApiConfigKit;
import com.jfinal.weixin.sdk.api.SnsAccessToken;
import com.jfinal.weixin.sdk.jfinal.ApiController;
import com.zskk.model.UserWechat;
import com.zskk.service.ServiceFactory;
import com.zskk.service.UserService;
import com.zskk.service.WeixinService;

public class WebBridgeController extends ApiController {

	private static String WEB_BASR_URL = "https://wechatclient3.pacsonline.cn/#";
	
	private static String WEB_BASR_URL_4 = "https://wc4.pacsonline.cn/#";

	
	public void addBinding() {
		this.process(WEB_BASR_URL_4+"/select");
	}
	
	public void examList() {
		System.out.println(ApiConfigKit.getApiConfig().getAppId());
		System.out.println(getRequest().getRequestURL().toString());
		this.process(WEB_BASR_URL_4+"/reportList");
	}

	public void aboutUs() {
		this.redirect("http://wechat.pacsonline.cn/pacs_online/html/aboutAs_zskk.html");
	}
	
	public void remoteDiagnosis() {
		this.process(WEB_BASR_URL_4+"/remoteList?appId=" + ApiConfigKit.getAppId());
	}
	
	public void test4() {
		this.process("https://wc4.pacsonline.cn/#/select");
	}
	
	public void test5() {
		this.process("https://wc4.pacsonline.cn/#/filmQuery?institution_id=13000003");
	}
	
	public void examPortrait() {
		this.process(WEB_BASR_URL_4+"/reportInfo/portrait?study_id=" + this.getPara("study_id"));
	}
	
	public void localReport() {
		this.process(WEB_BASR_URL_4+"/reportInfo/report?report_id=" + this.getPara("report_id"));
	}
	
	public void localReport2() {
//		this.renderText(WEB_BASR_URL_4+"/reportInfo/report?report_id="+ this.getPara("report_id"));
		this.process2(WEB_BASR_URL_4+"/reportInfo/report?report_id=" + this.getPara("report_id"));
	}
	
	private void process(String toUrl) {
		try {
//			System.out.println(toUrl);
//			System.out.println(getRequest().getRequestURL().toString());
//			Object sessionObj = this.getRequest().getSession().getAttribute("pwpSessionObjtest9");
			Object sessionObj = null;
			WeixinService wService = ServiceFactory.getService(WeixinService.class);
			if (sessionObj == null) {
				String code = this.getPara("code");
				if (code == null) {
//					System.out.println(ApiConfigKit.getApiConfig().getAppId());
//					System.out.println(getRequest().getRequestURL().toString());
					String paramString = getRequest().getQueryString()==null?"":"?"+getRequest().getQueryString();
					String url = wService.getCodeUrl(ApiConfigKit.getApiConfig().getAppId(), getRequest().getRequestURL().toString() + paramString);
					this.redirect(url);
					return;
				}
//				System.out.println(ApiConfigKit.getApiConfig().getAppId());
				SnsAccessToken snsAccessToken = wService.getWebAccessToken(ApiConfigKit.getApiConfig().getAppId(), ApiConfigKit.getApiConfig().getAppSecret(), code);

				UserService uService = ServiceFactory.getService(UserService.class);
				UserWechat user = UserWechat.dao.findFirst("select * from user_wechat where wx_openid=?",snsAccessToken.getOpenid());

				if (user == null && snsAccessToken.getOpenid() != null) {
					user = uService.createWxUserByAppid(snsAccessToken.getOpenid(), ApiConfigKit.getApiConfig().getAppId());
				}
				if (user != null && user.getWxIcon().isEmpty()) {                     
					wService.getWebWeixinUserInfo(snsAccessToken.getAccessToken(), snsAccessToken.getOpenid());
				}
				this.getRequest().getSession().setAttribute("pwpSessionObjtest9", user);
				String uidStr = toUrl.contains("?") ? "&openid=" : "?openid=";
				this.redirect(toUrl + uidStr + snsAccessToken.getOpenid());
			} else {
				UserService uService = ServiceFactory.getService(UserService.class);
				UserWechat userWechats = (UserWechat) sessionObj;
				UserWechat users = UserWechat.dao.findById(userWechats.getId());
				String uidStr = toUrl.contains("?") ? "&openid=" : "?openid=";
				if (users == null) {
					userWechats = uService.createWxUserByAppid(userWechats.getWxOpenid(), ApiConfigKit.getApiConfig().getAppId());
				}
				UserWechat users2 = UserWechat.dao.findFirst("select * from user_wechat where wx_openid=?",userWechats.getWxOpenid());
				if (users2 != null && users2.getWxIcon().isEmpty()) {
//					uService.getUserInfo(userWechats.getWxOpenid());
//					wService.getWebWeixinUserInfo(snsAccessToken.getAccessToken(), snsAccessToken.getOpenid());

				}
				
				this.getRequest().getSession().setAttribute("pwpSessionObjtest9", users2);

				this.redirect(toUrl + uidStr + userWechats.getWxOpenid());

				
			}
		} catch (Exception e) {
			// nothing
//			this.redirect("http://www.pacsonline.cn");
			this.renderText(e.toString());
		}
		
	}
	
	
	private void process2(String toUrl) {
		try {
			System.out.println(toUrl);
//			System.out.println(getRequest().getRequestURL().toString());
			renderText(getRequest().getQueryString());
			return;
//			Object sessionObj = null;
//			WeixinService wService = ServiceFactory.getService(WeixinService.class);
//			if (sessionObj == null) {
//				String code = this.getPara("code");
//				if (code == null) {
//					System.out.println(ApiConfigKit.getApiConfig().getAppId());
//					System.out.println(getRequest().getRequestURL().toString());
////					String uidStr = toUrl.contains("?") ? "&appId=" : "?appId=";
//					String url = wService.getCodeUrl(ApiConfigKit.getApiConfig().getAppId(), getRequest().getRequestURL().toString());
//					this.redirect(url);
//					return;
//				}
//				System.out.println(ApiConfigKit.getApiConfig().getAppId());
//				SnsAccessToken snsAccessToken = wService.getWebAccessToken(ApiConfigKit.getApiConfig().getAppId(), ApiConfigKit.getApiConfig().getAppSecret(), code);
//
//				UserService uService = ServiceFactory.getService(UserService.class);
//				UserWechat user = UserWechat.dao.findFirst("select * from user_wechat where wx_openid=?",snsAccessToken.getOpenid());
//
//				if (user == null && snsAccessToken.getOpenid() != null) {
//					user = uService.createWxUserByAppid(snsAccessToken.getOpenid(), ApiConfigKit.getApiConfig().getAppId());
//				}
//				if (user != null && user.getWxIcon().isEmpty()) {                     
//					wService.getWebWeixinUserInfo(snsAccessToken.getAccessToken(), snsAccessToken.getOpenid());
//				}
//				this.getRequest().getSession().setAttribute("pwpSessionObjtest9", user);
//				String uidStr = toUrl.contains("?") ? "&openid=" : "?openid=";
//				this.redirect(toUrl + uidStr + snsAccessToken.getOpenid());
//			} else {
//				UserService uService = ServiceFactory.getService(UserService.class);
//				UserWechat userWechats = (UserWechat) sessionObj;
//				UserWechat users = UserWechat.dao.findById(userWechats.getId());
//				String uidStr = toUrl.contains("?") ? "&openid=" : "?openid=";
//				if (users == null) {
//					userWechats = uService.createWxUserByAppid(userWechats.getWxOpenid(), ApiConfigKit.getApiConfig().getAppId());
//				}
//				UserWechat users2 = UserWechat.dao.findFirst("select * from user_wechat where wx_openid=?",userWechats.getWxOpenid());
//				if (users2 != null && users2.getWxIcon().isEmpty()) {
////					uService.getUserInfo(userWechats.getWxOpenid());
////					wService.getWebWeixinUserInfo(snsAccessToken.getAccessToken(), snsAccessToken.getOpenid());
//
//				}
//				
//				this.getRequest().getSession().setAttribute("pwpSessionObjtest9", users2);
//
//				this.redirect(toUrl + uidStr + userWechats.getWxOpenid());
//
//				
//			}
		} catch (Exception e) {
			// nothing
//			this.redirect("http://www.pacsonline.cn");
			this.renderText(e.toString());
		}
	}
}
